He tenido el mismo problema de eslint durante días.

Todos en el equipo tienen la misma versión de eslintrc e instalada de eslint. Su eslint funciona bien, el mío no.

He intentado reiniciar mi computadora, eliminar node_modules, eliminar cualquier cosa debajo de mi usuario (en el directorio de inicio). Nada funciona.

Problema:

./node_modules/.bin/eslint *.js* 
                                                                          1 ↵  11504  10:19:47
Cannot read property 'range' of null
TypeError: Cannot read property 'range' of null
    at SourceCode.getTokenBefore (/Users/jhill/gitRepo/sponsoroo/node_modules/eslint/lib/token-store/index.js:303:18)
    at checkSpacingBefore (/Users/jhill/gitRepo/sponsoroo/node_modules/eslint/lib/rules/template-curly-spacing.js:52:42)
    at TemplateElement (/Users/jhill/gitRepo/sponsoroo/node_modules/eslint/lib/rules/template-curly-spacing.js:117:17)
    at listeners.(anonymous function).forEach.listener (/Users/jhill/gitRepo/sponsoroo/node_modules/eslint/lib/util/safe-emitter.js:47:58)
    at Array.forEach (<anonymous>)
    at Object.emit (/Users/jhill/gitRepo/sponsoroo/node_modules/eslint/lib/util/safe-emitter.js:47:38)
    at NodeEventGenerator.applySelector (/Users/jhill/gitRepo/sponsoroo/node_modules/eslint/lib/util/node-event-generator.js:251:26)
    at NodeEventGenerator.applySelectors (/Users/jhill/gitRepo/sponsoroo/node_modules/eslint/lib/util/node-event-generator.js:280:22)
    at NodeEventGenerator.enterNode (/Users/jhill/gitRepo/sponsoroo/node_modules/eslint/lib/util/node-event-generator.js:294:14)
    at CodePathAnalyzer.enterNode (/Users/jhill/gitRepo/sponsoroo/node_modules/eslint/lib/code-path-analysis/code-path-analyzer.js:608:23)

Detalles

Versión:

./node_modules/.bin/eslint --version  

v4.16.0

.eslintrc

{
  "extends": ["airbnb-base", "plugin:security/recommended"],
  "rules": {
      "import/prefer-default-export": "off",
      "no-console": "off",
      "class-methods-use-this": "off",
      "global-require": "off",
      "consistent-return": "off",
      "import/no-extraneous-dependencies": ["error", {"devDependencies": true}],

      /* JSX */
      "jsx-quotes": [2, "prefer-double"],

      /* React */
      "react/display-name": 1,
      "react/jsx-boolean-value": 1,
      "react/jsx-no-duplicate-props": 1,
      "react/jsx-no-undef": 1,
      "react/jsx-quotes": 0,
      "react/jsx-sort-props": 0,
      "react/jsx-uses-react": 1,
      "react/jsx-uses-vars": 1,
      "react/no-danger": 1,
      "react/no-did-mount-set-state": 1,
      "react/no-did-update-set-state": 1,
      "react/no-multi-comp": 1,
      "react/no-unknown-property": 1,
      "react/prop-types": 1,
      "react/react-in-jsx-scope": 1,
      "react/self-closing-comp": 1,
      "react/sort-comp": 1,
      "react/wrap-multilines": 0,

      /* Security */
      "security/detect-non-literal-fs-filename": 2,
      "security/detect-non-literal-regexp": 2,
      "security/detect-unsafe-regex": 2,
      "security/detect-buffer-noassert": 2,
      "security/detect-child-process": 2,
      "security/detect-disable-mustache-escape": 2,
      "security/detect-eval-with-expression": 2,
      "security/detect-no-csrf-before-method-override": 2,
      "security/detect-non-literal-require": 2,
      "security/detect-object-injection": 2,
      "security/detect-possible-timing-attacks": 1,
      "security/detect-pseudoRandomBytes": 2,
      "no-unsafe-innerhtml/no-unsafe-innerhtml": 2
  },
  "parser": "babel-eslint",
  "plugins": [
    "babel",
    "react",
    "security",
    "no-unsafe-innerhtml"
  ],
  "env": {
    "jest": true,
    "browser": true,
    "es6": true,
    "node": true
  },
  "settings": {
    "import/extensions": {
      "webpack": {
        "config": "./webpack.config.react.js"
      }
    }
  }
}

Además, si elimino "parser": "babel-eslint" de mi .eslintrc, el problema / error desaparece, pero mi eslint no funciona. Estoy usando la sintaxis ES6.

Actualizar:

Mi solución fue usar hilo en lugar de npm. Ha resuelto el problema por el momento.

6
jcgh582 23 ene. 2018 a las 02:31

3 respuestas

La mejor respuesta

Arregle la versión de babel-eslint a 7.2.3 o 8.0.1 ejecutando:

npm install --save-dev babel-eslint@7.2.3

O:

npm install --save-dev babel-eslint@8.0.1
5
Brady Dowling 16 may. 2019 a las 17:23

Estas reglas .eslintrc me solucionaron el problema:

rules : {
  "template-curly-spacing" : "off",
  "indent": ["error", 2, {
    "ignoredNodes": ["TemplateLiteral"]
  }]
}
10
Ilyich 19 dic. 2019 a las 17:10

Como @Vasan mencionó, específicamente, en número 530, este fue el comentario que me ayudó a resolver el problema:

Lo más probable es que el problema esté causando un análisis incorrecto.

import(`some_path/${variable}`) // issue exists

Fix

import("some_path" + variable) // issue fixed
3
whoan 9 mar. 2020 a las 00:27
48391913